"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const bottom_tabs_1 = require("@react-navigation/bottom-tabs");
const native_stack_1 = require("@react-navigation/native-stack");
const NavigatorBar_1 = __importDefault(require("../NavigatorBar"));
const react_redux_1 = require("react-redux");
const react_native_1 = require("react-native");
const storage_1 = require("../Fn/storage");
const native_1 = require("@react-navigation/native");
const Tab = (0, bottom_tabs_1.createBottomTabNavigator)();
const Stack = (0, native_stack_1.createNativeStackNavigator)();
;
const TabsNavigation = ({ tabs = [], }) => {
    const { styleSafe } = (0, react_redux_1.useSelector)((state) => state.common);
    return (react_1.default.createElement(react_native_1.SafeAreaView, { style: Object.assign({}, styleSafe) },
        react_1.default.createElement(Tab.Navigator, { screenOptions: {
                headerShown: false,
                tabBarHideOnKeyboard: true,
            }, tabBar: (props) => react_1.default.createElement(NavigatorBar_1.default, Object.assign({}, props)) }, tabs.map((v, k) => {
            if (!v.tab)
                return null;
            return (react_1.default.createElement(Tab.Screen, { key: `itabs_${k}`, name: v.name, component: v.component, options: Object.assign({}, v) }));
        }))));
};
;
const Route = ({ routes = [], }) => {
    const navigationRef = (0, native_1.useNavigationContainerRef)();
    let { start, login } = (0, react_redux_1.useSelector)((state) => state.common);
    (0, react_1.useEffect)(() => {
        if (!login)
            return;
        (0, storage_1.$clearStorage)();
        navigationRef.resetRoot({
            index: 0,
            routes: [{ name: 'user/login' }],
        });
    }, [login]);
    const renderView = () => {
        return (react_1.default.createElement(Stack.Navigator, { initialRouteName: start || 'Index', screenOptions: {
                headerShown: false
            } },
            react_1.default.createElement(Stack.Screen, { name: 'Index' }, () => react_1.default.createElement(TabsNavigation, { tabs: routes })), routes === null || routes === void 0 ? void 0 :
            routes.map((v, k) => {
                if (v.tab)
                    return null;
                return (react_1.default.createElement(Stack.Screen, { key: `menu_${k}`, name: v.name, component: v.component }));
            })));
    };
    return (react_1.default.createElement(native_1.NavigationContainer, { ref: navigationRef }, renderView()));
};
exports.default = Route;
